using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DemoApp
{
	/// <summary>
	/// Descripcin breve de Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Variable del diseador requerida.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Necesario para admitir el Diseador de Windows Forms
			//
			InitializeComponent();

			//
			// TODO: agregar cdigo de constructor despus de llamar a InitializeComponent
			//
		}

		/// <summary>
		/// Limpiar los recursos que se estn utilizando.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Cdigo generado por el Diseador de Windows Forms
		/// <summary>
		/// Mtodo necesario para admitir el Diseador. No se puede modificar
		/// el contenido del mtodo con el editor de cdigo.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 32);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Abrir Form 2";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(24, 72);
			this.button2.Name = "button2";
			this.button2.TabIndex = 1;
			this.button2.Text = "Abrir Form 2";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private System.Windows.Forms.Button button2;

		private System.Windows.Forms.Button button1;


		private void button1_Click(object sender, System.EventArgs e)
		{
            AbrirVentana(typeof(Form2));		
		}
	
		private void button2_Click(object sender, System.EventArgs e)
		{
			AbrirVentana("DemoApp.Form2");
		}

		#region Utils

		public Hashtable instancias = new Hashtable();

		public Form AbrirVentana(Type tipo)
		{
			return AbrirVentana(tipo.FullName);
		}
	
		public Form AbrirVentana(string tipo)
		{
			try
			{
				Form formulario = instancias[tipo] as Form;
				if (formulario == null || formulario.IsDisposed)
				{
					formulario = (Form)Activator.CreateInstance(null, tipo).Unwrap();
					instancias[tipo] = formulario;
				}
				if (this.IsMdiContainer)
					formulario.MdiParent = this;

				formulario.Activate();
				formulario.WindowState = FormWindowState.Normal;
				formulario.Show();
				return formulario;
			}
			catch (Exception ex)
			{
				// Procesar el error
				throw ex; // return null;
			}
		}
		#endregion
	}
}
